/* this file was generated by the MCOP idl compiler - DO NOT EDIT */

#ifndef MODPLUG_H
#define MODPLUG_H

#include "common.h"

// includes of other idl definitions
#include "kmedia2.h"
#include "artsflow.h"
#include "soundserver.h"
#include "core.h"

class ModplugPlayObject;

class ModplugPlayObject_base : virtual public Arts::PlayObject_base,
	virtual public Arts::SynthModule_base,
	virtual public Arts::PitchablePlayObject_base {
public:
	static unsigned long _IID; // interface ID

	static ModplugPlayObject_base *_create(const std::string& subClass = "ModplugPlayObject");
	static ModplugPlayObject_base *_fromString(const std::string& objectref);
	static ModplugPlayObject_base *_fromReference(Arts::ObjectReference ref, bool needcopy);

	static ModplugPlayObject_base *_fromDynamicCast(const Arts::Object& object);
	inline ModplugPlayObject_base *_copy() {
		assert(_refCnt > 0);
		_refCnt++;
		return this;
	}

	virtual std::vector<std::string> _defaultPortsIn() const;
	virtual std::vector<std::string> _defaultPortsOut() const;

	void *_cast(unsigned long iid);

	virtual bool agc() = 0;
	virtual void agc(bool newValue) = 0;
	virtual long bps() = 0;
	virtual void bps(long newValue) = 0;
	virtual bool setXBassParameters(long depth, long range) = 0;
	virtual std::vector<std::string> * samples() = 0;
	virtual std::vector<std::string> * instruments() = 0;
	virtual std::string comments() = 0;
};

class ModplugPlayObject_stub : virtual public ModplugPlayObject_base, virtual public Arts::PlayObject_stub,
	virtual public Arts::SynthModule_stub,
	virtual public Arts::PitchablePlayObject_stub {
protected:
	ModplugPlayObject_stub();

public:
	ModplugPlayObject_stub(Arts::Connection *connection, long objectID);

	bool agc();
	void agc(bool newValue);
	long bps();
	void bps(long newValue);
	bool setXBassParameters(long depth, long range);
	std::vector<std::string> * samples();
	std::vector<std::string> * instruments();
	std::string comments();
};

class ModplugPlayObject_skel : virtual public ModplugPlayObject_base, virtual public Arts::PlayObject_skel,
	virtual public Arts::SynthModule_skel,
	virtual public Arts::PitchablePlayObject_skel {
protected:
	// variables for streams
	float *left;                              // outgoing stream
	float *right;                             // outgoing stream

protected:
	// emitters for change notifications
	inline void agc_changed(bool newValue) {
		_emit_changed("agc_changed",newValue);
	}
	inline void bps_changed(long newValue) {
		_emit_changed("bps_changed",newValue);
	}

public:
	ModplugPlayObject_skel();

	static std::string _interfaceNameSkel();
	std::string _interfaceName();
	bool _isCompatibleWith(const std::string& interfacename);
	void _buildMethodTable();
	void dispatch(Arts::Buffer *request, Arts::Buffer *result,long methodID);
};

#include "reference.h"
class ModplugPlayObject : public Arts::Object {
private:
	static Arts::Object_base* _Creator();
	ModplugPlayObject_base *_cache;
	inline ModplugPlayObject_base *_method_call() {
		_pool->checkcreate();
		if(_pool->base) {
			_cache=(ModplugPlayObject_base *)_pool->base->_cast(ModplugPlayObject_base::_IID);
			assert(_cache);
		}
		return _cache;
	}

protected:
	inline ModplugPlayObject(ModplugPlayObject_base* b) : Arts::Object(b), _cache(0) {}


public:
	typedef ModplugPlayObject_base _base_class;

	inline ModplugPlayObject() : Arts::Object(_Creator), _cache(0) {}
	inline ModplugPlayObject(const Arts::SubClass& s) :
		Arts::Object(ModplugPlayObject_base::_create(s.string())), _cache(0) {}
	inline ModplugPlayObject(const Arts::Reference &r) :
		Arts::Object(r.isString()?(ModplugPlayObject_base::_fromString(r.string())):(ModplugPlayObject_base::_fromReference(r.reference(),true))), _cache(0) {}
	inline ModplugPlayObject(const Arts::DynamicCast& c) : Arts::Object(ModplugPlayObject_base::_fromDynamicCast(c.object())), _cache(0) {}
	inline ModplugPlayObject(const ModplugPlayObject& target) : Arts::Object(target._pool), _cache(target._cache) {}
	inline ModplugPlayObject(Arts::Object::Pool& p) : Arts::Object(p), _cache(0) {}
	inline static ModplugPlayObject null() {return ModplugPlayObject((ModplugPlayObject_base*)0);}
	inline static ModplugPlayObject _from_base(ModplugPlayObject_base* b) {return ModplugPlayObject(b);}
	inline ModplugPlayObject& operator=(const ModplugPlayObject& target) {
		if (_pool == target._pool) return *this;
		_pool->Dec();
		_pool = target._pool;
		_cache = target._cache;
		_pool->Inc();
		return *this;
	}
	inline operator Arts::PlayObject() const { return Arts::PlayObject(*_pool); }
	inline operator Arts::PlayObject_private() const { return Arts::PlayObject_private(*_pool); }
	inline operator Arts::SynthModule() const { return Arts::SynthModule(*_pool); }
	inline operator Arts::PitchablePlayObject() const { return Arts::PitchablePlayObject(*_pool); }
	inline ModplugPlayObject_base* _base() {return _cache?_cache:_method_call();}

	inline std::string description();
	inline Arts::poTime currentTime();
	inline Arts::poTime overallTime();
	inline Arts::poCapabilities capabilities();
	inline std::string mediaName();
	inline Arts::poState state();
	inline void play();
	inline void seek(const Arts::poTime& newTime);
	inline void pause();
	inline void halt();
	inline bool loadMedia(const std::string& filename);
	inline Arts::AutoSuspendState autoSuspend();
	inline void start();
	inline void stop();
	inline void streamInit();
	inline void streamStart();
	inline void streamEnd();
	inline float speed();
	inline void speed(float _newValue);
	inline bool agc();
	inline void agc(bool _newValue);
	inline long bps();
	inline void bps(long _newValue);
	inline bool setXBassParameters(long depth, long range);
	inline std::vector<std::string> * samples();
	inline std::vector<std::string> * instruments();
	inline std::string comments();
};

// Forward wrapper calls to _base classes:

inline std::string ModplugPlayObject::description()
{
	return _cache?static_cast<Arts::PlayObject_base*>(_cache)->description():static_cast<Arts::PlayObject_base*>(_method_call())->description();
}

inline Arts::poTime ModplugPlayObject::currentTime()
{
	return _cache?static_cast<Arts::PlayObject_base*>(_cache)->currentTime():static_cast<Arts::PlayObject_base*>(_method_call())->currentTime();
}

inline Arts::poTime ModplugPlayObject::overallTime()
{
	return _cache?static_cast<Arts::PlayObject_base*>(_cache)->overallTime():static_cast<Arts::PlayObject_base*>(_method_call())->overallTime();
}

inline Arts::poCapabilities ModplugPlayObject::capabilities()
{
	return _cache?static_cast<Arts::PlayObject_base*>(_cache)->capabilities():static_cast<Arts::PlayObject_base*>(_method_call())->capabilities();
}

inline std::string ModplugPlayObject::mediaName()
{
	return _cache?static_cast<Arts::PlayObject_base*>(_cache)->mediaName():static_cast<Arts::PlayObject_base*>(_method_call())->mediaName();
}

inline Arts::poState ModplugPlayObject::state()
{
	return _cache?static_cast<Arts::PlayObject_base*>(_cache)->state():static_cast<Arts::PlayObject_base*>(_method_call())->state();
}

inline void ModplugPlayObject::play()
{
	 _cache?static_cast<Arts::PlayObject_base*>(_cache)->play():static_cast<Arts::PlayObject_base*>(_method_call())->play();
}

inline void ModplugPlayObject::seek(const Arts::poTime& newTime)
{
	 _cache?static_cast<Arts::PlayObject_base*>(_cache)->seek(newTime):static_cast<Arts::PlayObject_base*>(_method_call())->seek(newTime);
}

inline void ModplugPlayObject::pause()
{
	 _cache?static_cast<Arts::PlayObject_base*>(_cache)->pause():static_cast<Arts::PlayObject_base*>(_method_call())->pause();
}

inline void ModplugPlayObject::halt()
{
	 _cache?static_cast<Arts::PlayObject_base*>(_cache)->halt():static_cast<Arts::PlayObject_base*>(_method_call())->halt();
}

inline bool ModplugPlayObject::loadMedia(const std::string& filename)
{
	return _cache?static_cast<Arts::PlayObject_private_base*>(_cache)->loadMedia(filename):static_cast<Arts::PlayObject_private_base*>(_method_call())->loadMedia(filename);
}

inline Arts::AutoSuspendState ModplugPlayObject::autoSuspend()
{
	return _cache?static_cast<Arts::SynthModule_base*>(_cache)->autoSuspend():static_cast<Arts::SynthModule_base*>(_method_call())->autoSuspend();
}

inline void ModplugPlayObject::start()
{
	 _cache?static_cast<Arts::SynthModule_base*>(_cache)->start():static_cast<Arts::SynthModule_base*>(_method_call())->start();
}

inline void ModplugPlayObject::stop()
{
	 _cache?static_cast<Arts::SynthModule_base*>(_cache)->stop():static_cast<Arts::SynthModule_base*>(_method_call())->stop();
}

inline void ModplugPlayObject::streamInit()
{
	 _cache?static_cast<Arts::SynthModule_base*>(_cache)->streamInit():static_cast<Arts::SynthModule_base*>(_method_call())->streamInit();
}

inline void ModplugPlayObject::streamStart()
{
	 _cache?static_cast<Arts::SynthModule_base*>(_cache)->streamStart():static_cast<Arts::SynthModule_base*>(_method_call())->streamStart();
}

inline void ModplugPlayObject::streamEnd()
{
	 _cache?static_cast<Arts::SynthModule_base*>(_cache)->streamEnd():static_cast<Arts::SynthModule_base*>(_method_call())->streamEnd();
}

inline float ModplugPlayObject::speed()
{
	return _cache?static_cast<Arts::PitchablePlayObject_base*>(_cache)->speed():static_cast<Arts::PitchablePlayObject_base*>(_method_call())->speed();
}

inline void ModplugPlayObject::speed(float _newValue)
{
	 _cache?static_cast<Arts::PitchablePlayObject_base*>(_cache)->speed(_newValue):static_cast<Arts::PitchablePlayObject_base*>(_method_call())->speed(_newValue);
}

inline bool ModplugPlayObject::agc()
{
	return _cache?static_cast<ModplugPlayObject_base*>(_cache)->agc():static_cast<ModplugPlayObject_base*>(_method_call())->agc();
}

inline void ModplugPlayObject::agc(bool _newValue)
{
	 _cache?static_cast<ModplugPlayObject_base*>(_cache)->agc(_newValue):static_cast<ModplugPlayObject_base*>(_method_call())->agc(_newValue);
}

inline long ModplugPlayObject::bps()
{
	return _cache?static_cast<ModplugPlayObject_base*>(_cache)->bps():static_cast<ModplugPlayObject_base*>(_method_call())->bps();
}

inline void ModplugPlayObject::bps(long _newValue)
{
	 _cache?static_cast<ModplugPlayObject_base*>(_cache)->bps(_newValue):static_cast<ModplugPlayObject_base*>(_method_call())->bps(_newValue);
}

inline bool ModplugPlayObject::setXBassParameters(long depth, long range)
{
	return _cache?static_cast<ModplugPlayObject_base*>(_cache)->setXBassParameters(depth, range):static_cast<ModplugPlayObject_base*>(_method_call())->setXBassParameters(depth, range);
}

inline std::vector<std::string> * ModplugPlayObject::samples()
{
	return _cache?static_cast<ModplugPlayObject_base*>(_cache)->samples():static_cast<ModplugPlayObject_base*>(_method_call())->samples();
}

inline std::vector<std::string> * ModplugPlayObject::instruments()
{
	return _cache?static_cast<ModplugPlayObject_base*>(_cache)->instruments():static_cast<ModplugPlayObject_base*>(_method_call())->instruments();
}

inline std::string ModplugPlayObject::comments()
{
	return _cache?static_cast<ModplugPlayObject_base*>(_cache)->comments():static_cast<ModplugPlayObject_base*>(_method_call())->comments();
}

#endif /* MODPLUG_H */
